/*
 * $Id: RSSConcreteInterfaceFactory.java,v 1.4 2005/05/31 14:38:21 rampil Exp $
 * Copyright (c) 2004 LOGICAL-PARADOX.ORG
 */
package org.logical_paradox.koike.rss;

import java.util.Iterator;

import org.logical_paradox.koike.core.ConcreteInterfaceFactory;
import org.logical_paradox.koike.core.document.DocumentAccessor;
import org.logical_paradox.koike.core.indexer.IndexAccessor;
import org.logical_paradox.koike.core.search.SearchConditionOptimizer;
import org.logical_paradox.koike.rss.document.RSSDocumentAccessor;
import org.logical_paradox.koike.rss.document.RemoteQueueCollection;
import org.logical_paradox.koike.rss.indexer.RSSIndexAccessor;
import org.logical_paradox.koike.rss.search.RSSSearchConditionOptimizer;
import org.logical_paradox.rss.dsr.RSSDistributedServiceRegistry;
import org.logical_paradox.rss.idxsv.IndexConnection;
import org.logical_paradox.rss.idxsv.RSSIndexServer;
import org.logical_paradox.rss.lookup.Lookup;
import org.logical_paradox.rss.lookup.LookupFactory;
import org.logical_paradox.rss.oqs4r.OQSConnection;
import org.logical_paradox.rss.oqs4r.ObjectQueueServer;
import org.logical_paradox.rss.rcm.ContentsFinder;
import org.logical_paradox.rss.rcm.RSSContentsMngrService;

/**
 * RSSɐڑ^CṽC^[tF[X𐶐t@Ng
 * 
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.4 $
 */
public class RSSConcreteInterfaceFactory extends ConcreteInterfaceFactory {
	// bNAbv
	private Lookup lookup;
	// L[
	private OQSConnection qConnection;
	// RecǗVXeɂČst@C_[
	private ContentsFinder finder;
	// CfbNXT[o[֐ڑC^[tF[X
	private IndexConnection idxConnection;

	/**
	 * RXgN^
	 * @param param p[^
	 * @throws Exception t@Ng̏Ɏs
	 */
	public RSSConcreteInterfaceFactory(String param) throws Exception {
		super(param);
	}
	/**
	 * ꂽhLgANZT𐶐ĕԂ
	 * @return ꂽhLgANZT
	 * @throws Exception ܂͏ɎsꍇɔO
	 */
	public DocumentAccessor getDocumentAccessor() throws Exception {
		return new RSSDocumentAccessor(finder);
	}
	/**
	 * CfbNXANZT𐶐ĕԂ
	 * @return ꂽCfbNXANZT
	 * @throws Exception ܂͏ɎsꍇɔO
	 */
	public IndexAccessor getIndexAccessor() throws Exception {
		return new RSSIndexAccessor(idxConnection);
	}
	/**
	 * [gL[ɐڑĂCe[^Ԃ
	 * @return [gL[V[PVɃRec擾łCe[^
	 */
	public Iterator getRemoteQueueIterator() throws Exception {
		return new RemoteQueueCollection(qConnection).iterator();
	}
	/**
	 * œKԂ
	 * @return ꂽœKWbN
	 * @throws Exception ɔO
	 */
	public SearchConditionOptimizer getOptimizer() throws Exception {
		return new RSSSearchConditionOptimizer();
	}
	/**
	 * t@Ng̏
	 * @throws Exception Ɏs
	 */
	public void setup() throws Exception {
		lookup = LookupFactory.getLookup(getInitparam());

		// RecL[T
		ObjectQueueServer queue = (ObjectQueueServer)lookup.lookup(RSSDistributedServiceRegistry.RSS_SERVID_OQS4R);
		qConnection = queue.getConnection();

		// RecǗVXeT
		RSSContentsMngrService rcm = (RSSContentsMngrService)lookup.lookup(RSSDistributedServiceRegistry.RSS_SERVID_REMOTE_CONTENTS_MGR);
		finder = rcm.getFinder();

		// CfbNXT[o[T
		RSSIndexServer idxsv = (RSSIndexServer)lookup.lookup(RSSDistributedServiceRegistry.RSS_SERVID_INDEX_SERVER);
		idxConnection = idxsv.getClient();
	}
}
